﻿using System;

namespace DeviceBridge
{
    public class DeviceCommands
    {
        static public uint CMD_SUCCESS = 1;
        static public uint CMD_ERROR = 2;

        static public uint CMD_LED_RUN_ON = 10;
        static public uint CMD_LED_RUN_OFF = 11;

        static public uint CMD_LED_RX_ON = 20;
        static public uint CMD_LED_RX_OFF = 21;

        static public uint CMD_LED_CYCLE_ON = 30;
        static public uint CMD_LED_CYCLE_OFF = 31;

        static public uint CMD_SERVO_GYRO = 32;
        static public uint CMD_SERVO_FLAG = 33;

        public static string[] GetAllCommands()
        {
            string[] oList = {
                        "Success",
                        "Error",
                        "Run Led ON",
                        "Run Led OFF",
                        "RX Led ON",
                        "RX Led OFF",
                        "Cycle Led ON",
                        "Cycle Led OFF",
                        "Servo Gyro",
                        "Servo Flag"
                    };

            return oList;
        }

        public static uint GetCommandFromString(string sName)
        {
            if (sName == "Success")
            {
                return CMD_SUCCESS;
            }

            if (sName == "Run Led ON")
            {
                return CMD_LED_RUN_ON;
            }

            if (sName == "Run Led OFF")
            {
                return CMD_LED_RUN_OFF;
            }

            if (sName == "RX Led ON")
            {
                return CMD_LED_RX_ON;
            }

            if (sName == "RX Led OFF")
            {
                return CMD_LED_RX_OFF;
            }

            if (sName == "Cycle Led ON")
            {
                return CMD_LED_CYCLE_ON;
            }

            if (sName == "Cycle Led OFF")
            {
                return CMD_LED_CYCLE_OFF;
            }

            if (sName == "Servo Gyro")
            {
                return CMD_SERVO_GYRO;
            }

            if (sName == "Servo Flag")
            {
                return CMD_SERVO_FLAG;
            }

            return CMD_ERROR;
        }
    }
}
