﻿using System;
using System.IO.Ports;

namespace DeviceBridge
{
    public class SerialDevice
    {
        static private UInt32 m_nComPort = 1;

        public UInt32 ComPort
        {
            get
            {
                return m_nComPort;
            }

            set
            {
                m_nComPort = value;
            }
        }

        public bool SendCommandSuccess()
        {
            return SendCommand(DeviceCommands.CMD_SUCCESS);
        }

        public bool SendCommandFailure()
        {
            return SendCommand(DeviceCommands.CMD_ERROR);
        }

        public bool SendCommand(uint nCommand)
        {
            bool bResult = SendOneCommand(nCommand);
            System.Threading.Thread.Sleep(1000);
            return bResult;
        }

        private static bool SendOneCommand(UInt32 nCommand)
        {
            bool bResult = false;
            try
            {
                SerialPort ComPort = new SerialPort();
                ComPort.PortName = "COM" + m_nComPort;
                ComPort.BaudRate = 9600;

                ComPort.Open();

                System.Threading.Thread.Sleep(200);

                string sCmd = System.String.Empty;
                sCmd += GetCharFromCommand(nCommand);
                ComPort.Write(sCmd);

                System.Threading.Thread.Sleep(200);
                ComPort.Close();

                bResult = true;
            }
            catch (Exception)
            { }
            return bResult;
        }

        private static char GetCharFromCommand(UInt32 nCmd)
        {
            if (nCmd == DeviceCommands.CMD_SUCCESS)
            {
                return 'a';
            }
            else if (nCmd == DeviceCommands.CMD_ERROR)
            {
                return 'b';
            }
            else if (nCmd == DeviceCommands.CMD_LED_RUN_ON)
            {
                return 'o';
            }
            else if (nCmd == DeviceCommands.CMD_LED_RUN_OFF)
            {
                return 'p';
            }
            else if (nCmd == DeviceCommands.CMD_LED_RX_ON)
            {
                return 'q';
            }
            else if (nCmd == DeviceCommands.CMD_LED_RX_OFF)
            {
                return 'r';
            }
            else if (nCmd == DeviceCommands.CMD_LED_CYCLE_ON)
            {
                return 's';
            }
            else if (nCmd == DeviceCommands.CMD_LED_CYCLE_OFF)
            {
                return 't';
            }
            else if (nCmd == DeviceCommands.CMD_SERVO_GYRO)
            {
                return 'u';
            }
            else if (nCmd == DeviceCommands.CMD_SERVO_FLAG)
            {
                return 'v';
            }
            return ' ';
        }
    }

}
