﻿using System;
using System.Collections.Generic;

namespace VSTSConnector
{
    public class BuildInfoMonitor
    {
        private BuildInfoRetriever m_oRetriever = null;

        private List<BuildInfoItem> m_CurrentList = null;

        private bool m_bBuildInError = false;

        private DateTime m_TimeLimit;

        public BuildInfoMonitor(string sURL, string sProject)
        {
            m_oRetriever = new BuildInfoRetriever(sURL, sProject);

            m_TimeLimit= DateTime.Now;
            m_TimeLimit= m_TimeLimit.AddDays(-4);
        }

        public void AddBuildToMonitor(string sName)
        {
            m_oRetriever.AddBuildToMonitor(sName);
        }
        
        public bool IsBuildInError()
        {
            return m_bBuildInError;
        }

        public List<BuildInfoItem> GetBuilds()
        {
            List<BuildInfoItem> oList = new List<BuildInfoItem>();
            try
            {
                oList = m_oRetriever.GetBuildInfo();
                KeepLatestBuilds(ref oList);
                m_bBuildInError = AnalyzeLastBuildBatch(oList);
            }
            catch (Exception /*err*/)
            { }
            return oList;
        }

        private void KeepLatestBuilds(ref List<BuildInfoItem> oList)
        {
            oList.Sort();
            int nIndex = 0;
            while(nIndex<oList.Count)
            {
                if (oList[nIndex].FinishTime < m_TimeLimit)
                {
                    oList.RemoveAt(nIndex);
                }
                else
                {
                    nIndex++;
                }
            }
        }

        private bool AnalyzeLastBuildBatch(List<BuildInfoItem> oList)
        {
            BuildListComparer oComparer= new BuildListComparer();
            bool bError = oComparer.CompareList(m_CurrentList, oList);
            m_CurrentList = oList;
            return bError;
        }
    }
}
