﻿using System;
using VSTSConnector;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace VSTSConnectorTest
{
    [TestClass]
    public class BuildInfoItemTest
    {
        [TestMethod]
        public void TestCreation()
        {
            DateTime RefTime = DateTime.Now;

            BuildInfoItem oTst = new BuildInfoItem("name", "build", RefTime, "result");

            Assert.AreEqual("name", oTst.Name);
            Assert.AreEqual("build", oTst.BuildNumber);
            Assert.AreEqual(RefTime, oTst.FinishTime);
            Assert.AreEqual("result", oTst.Result);
        }
        [TestMethod]
        public void TestIsGreater()
        {
            DateTime time1 = DateTime.Now;
            DateTime time2 = time1.AddSeconds(1);

            BuildInfoItem oTst1 = new BuildInfoItem("name", "build", time1, "result");
            BuildInfoItem oTst2 = new BuildInfoItem("name", "build", time2, "result");

            Assert.AreEqual(1, oTst1.CompareTo(oTst2));
        }
        [TestMethod]
        public void TestIsEqual()
        {
            DateTime time1 = DateTime.Now;

            BuildInfoItem oTst1 = new BuildInfoItem("name", "build", time1, "result");
            BuildInfoItem oTst2 = new BuildInfoItem("name", "build", time1, "result");

            Assert.AreEqual(0, oTst1.CompareTo(oTst2));
        }

        [TestMethod]
        public void TestIsSmaller()
        {
            DateTime time1 = DateTime.Now;
            DateTime time2 = time1.AddSeconds(-1);

            BuildInfoItem oTst1 = new BuildInfoItem("name", "build", time1, "result");
            BuildInfoItem oTst2 = new BuildInfoItem("name", "build", time2, "result");

            Assert.AreEqual(-1, oTst1.CompareTo(oTst2));
        }
    }
}
